diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/test/wifi-emlsr-test.cc ns-3.40/src/wifi/test/wifi-emlsr-test.cc
--- ns-3.39/src/wifi/test/wifi-emlsr-test.cc	2023-07-05 14:23:48.129428400 -0700
+++ ns-3.40/src/wifi/test/wifi-emlsr-test.cc	2023-09-27 13:30:37.922839900 -0700
@@ -2351,142 +2435,181 @@
                               "Unexpected TA for BlockAck: " << taddr);
         clientId = 1;
     }
+
+    // find the link on which the main PHY is operating
+    auto currMainPhyLinkId = m_staMacs[clientId]->GetLinkForPhy(phyId);
+    NS_TEST_ASSERT_MSG_EQ(
+        currMainPhyLinkId.has_value(),
+        true,
+        "Didn't find the link on which the PHY sending the BlockAck is operating");
+    auto linkId = *currMainPhyLinkId;
+
     // we need the MLD address to check the status of the container queues
     auto addr = m_apMac->GetWifiRemoteStationManager(linkId)->GetMldAddress(taddr);
     NS_TEST_ASSERT_MSG_EQ(addr.has_value(), true, "MLD address not found for " << taddr);
 
     auto apPhy = m_apMac->GetWifiPhy(linkId);
     auto txDuration = WifiPhy::CalculateTxDuration(psduMap, txVector, apPhy->GetPhyBand());
-    auto timeout = apPhy->GetSifs() + apPhy->GetSlot() + MicroSeconds(20);
+    auto cfEndTxDuration = WifiPhy::CalculateTxDuration(
+        Create<WifiPsdu>(Create<Packet>(), WifiMacHeader(WIFI_MAC_CTL_END)),
+        m_apMac->GetWifiRemoteStationManager(linkId)->GetRtsTxVector(Mac48Address::GetBroadcast()),
+        apPhy->GetPhyBand());
 
     m_countBlockAck++;
 
     switch (m_countBlockAck)
     {
     case 4:
-        // at the end of the PPDU carrying this BlockAck, the EMLSR client sending this
-        // frame will start a timeout interval, after which it will start the transition to
-        // the listening mode (such transition lasting the transition delay)
-
-        // immediately before the end of the PPDU plus timeout, this link is not blocked
-        // for the EMLSR client
-        Simulator::Schedule(txDuration + timeout - NanoSeconds(1), [=]() {
-            WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, *addr, 0);
-            auto mask = m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, linkId);
-            NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
-                                  true,
-                                  "Expected to find a mask for EMLSR link "
-                                      << +linkId << " of EMLSR client " << clientId);
-            NS_TEST_EXPECT_MSG_EQ(mask->none(),
-                                  true,
-                                  "Expected EMLSR link " << +linkId << " of EMLSR client "
-                                                         << clientId << " to be unblocked");
+        // the PPDU carrying this BlockAck is corrupted, hence the AP MLD MAC receives the
+        // PHY-RXSTART indication but it does not receive any frame from the PHY. Therefore,
+        // at the end of the PPDU transmission, the AP MLD realizes that the EMLSR client has
+        // not responded and makes an attempt at continuing the TXOP
+
+        // at the end of the PPDU, this link only is not blocked on both the EMLSR client and
+        // the AP MLD
+        Simulator::Schedule(txDuration, [=]() {
+            for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
+            {
+                CheckBlockedLink(m_staMacs[clientId],
+                                 m_apMac->GetAddress(),
+                                 id,
+                                 WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                 id != linkId,
+                                 "Checking links on EMLSR client " + std::to_string(clientId) +
+                                     " at the end of fourth BlockAck");
+                CheckBlockedLink(m_apMac,
+                                 *addr,
+                                 id,
+                                 WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                 id != linkId,
+                                 "Checking links of EMLSR client " + std::to_string(clientId) +
+                                     " on the AP MLD at the end of fourth BlockAck");
+            }
         });
-        // immediately before the end of the PPDU plus timeout, the other links are blocked
-        // for the EMLSR client
-        Simulator::Schedule(txDuration + timeout - NanoSeconds(1), [=]() {
+        // a SIFS after the end of the PPDU, still this link only is not blocked on both the
+        // EMLSR client and the AP MLD
+        Simulator::Schedule(txDuration + apPhy->GetSifs(), [=]() {
             for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
             {
-                if (id == linkId)
-                {
-                    continue;
-                }
-
-                WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, *addr, 0);
-                auto mask = m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, id);
-                NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
-                                      true,
-                                      "Expected to find a mask for EMLSR link "
-                                          << +id << " of EMLSR client " << clientId);
-                auto reason =
-                    static_cast<std::size_t>(WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK);
-                NS_TEST_EXPECT_MSG_EQ(mask->test(reason),
-                                      true,
-                                      "Expected EMLSR link " << +id << " of EMLSR client "
-                                                             << clientId << " to be blocked");
-                NS_TEST_EXPECT_MSG_EQ(mask->count(),
-                                      1,
-                                      "Expected EMLSR link " << +id << " of EMLSR client "
-                                                             << clientId
-                                                             << " to be blocked "
-                                                                " for one reason only");
+                CheckBlockedLink(m_staMacs[clientId],
+                                 m_apMac->GetAddress(),
+                                 id,
+                                 WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                 id != linkId,
+                                 "Checking links on EMLSR client " + std::to_string(clientId) +
+                                     " a SIFS after the end of fourth BlockAck");
+                CheckBlockedLink(m_apMac,
+                                 *addr,
+                                 id,
+                                 WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                 id != linkId,
+                                 "Checking links of EMLSR client " + std::to_string(clientId) +
+                                     " a SIFS after the end of fourth BlockAck");
             }
         });
-        // immediately after the end of the PPDU plus timeout, all links are blocked for the EMLSR
-        // client
-        Simulator::Schedule(txDuration + timeout + MicroSeconds(1), [=]() {
+        // corrupt this BlockAck so that the AP MLD sends a BlockAckReq later on
+        {
+            auto uid = psduMap.cbegin()->second->GetPacket()->GetUid();
+            m_errorModel->SetList({uid});
+        }
+        break;
+    case 5:
+        // at the end of the PPDU, this link only is not blocked on both the EMLSR client and
+        // the AP MLD
+        Simulator::Schedule(txDuration, [=]() {
             for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
             {
-                WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, *addr, 0);
-                auto mask = m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, id);
-                NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
-                                      true,
-                                      "Expected to find a mask for EMLSR link "
-                                          << +id << " of EMLSR client " << clientId);
-                auto reason = static_cast<std::size_t>(
-                    WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY);
-                NS_TEST_EXPECT_MSG_EQ(mask->test(reason),
-                                      true,
-                                      "Expected EMLSR link " << +id << " of EMLSR client "
-                                                             << clientId << " to be blocked");
-                NS_TEST_EXPECT_MSG_EQ(mask->count(),
-                                      1,
-                                      "Expected EMLSR link " << +id << " of EMLSR client "
-                                                             << clientId
-                                                             << " to be blocked "
-                                                                " for one reason only");
+                CheckBlockedLink(m_staMacs[clientId],
+                                 m_apMac->GetAddress(),
+                                 id,
+                                 WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                 id != linkId,
+                                 "Checking links on EMLSR client " + std::to_string(clientId) +
+                                     " at the end of fifth BlockAck");
+                CheckBlockedLink(m_apMac,
+                                 *addr,
+                                 id,
+                                 WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                 id != linkId,
+                                 "Checking links of EMLSR client " + std::to_string(clientId) +
+                                     " on the AP MLD at the end of fifth BlockAck");
             }
         });
-        // immediately before the transition delay, all links are still blocked for the EMLSR client
+        // before the end of the CF-End frame, still this link only is not blocked on both the
+        // EMLSR client and the AP MLD
         Simulator::Schedule(
-            txDuration + timeout + m_transitionDelay.at(clientId) - NanoSeconds(1),
+            txDuration + apPhy->GetSifs() + cfEndTxDuration - MicroSeconds(1),
             [=]() {
                 for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
                 {
-                    WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, *addr, 0);
-                    auto mask =
-                        m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, id);
-                    NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
-                                          true,
-                                          "Expected to find a mask for EMLSR link "
-                                              << +id << " of EMLSR client " << clientId);
-                    auto reason = static_cast<std::size_t>(
-                        WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY);
-                    NS_TEST_EXPECT_MSG_EQ(mask->test(reason),
-                                          true,
-                                          "Expected EMLSR link " << +id << " of EMLSR client "
-                                                                 << clientId << " to be blocked");
-                    NS_TEST_EXPECT_MSG_EQ(mask->count(),
-                                          1,
-                                          "Expected EMLSR link " << +id << " of EMLSR client "
-                                                                 << clientId
-                                                                 << " to be blocked "
-                                                                    " for one reason only");
+                    CheckBlockedLink(m_staMacs[clientId],
+                                     m_apMac->GetAddress(),
+                                     id,
+                                     WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                     id != linkId,
+                                     "Checking links on EMLSR client " + std::to_string(clientId) +
+                                         " before the end of CF-End frame");
+                    CheckBlockedLink(m_apMac,
+                                     *addr,
+                                     id,
+                                     WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                     id != linkId,
+                                     "Checking links of EMLSR client " + std::to_string(clientId) +
+                                         " on the AP MLD before the end of CF-End frame");
                 }
             });
-        // immediately after the transition delay, all links are unblocked for the EMLSR client
+        // after the end of the CF-End frame, all links for the EMLSR client are blocked on the
+        // AP MLD
         Simulator::Schedule(
-            txDuration + timeout + m_transitionDelay.at(clientId) + MicroSeconds(1),
+            txDuration + apPhy->GetSifs() + cfEndTxDuration + MicroSeconds(1),
             [=]() {
                 for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
                 {
-                    WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, *addr, 0);
-                    auto mask =
-                        m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, id);
-                    NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
-                                          true,
-                                          "Expected to find a mask for EMLSR link "
-                                              << +id << " of EMLSR client " << clientId);
-                    NS_TEST_EXPECT_MSG_EQ(mask->none(),
-                                          true,
-                                          "Expected EMLSR link " << +id << " of EMLSR client "
-                                                                 << clientId << " to be unblocked");
+                    CheckBlockedLink(
+                        m_apMac,
+                        *addr,
+                        id,
+                        WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY,
+                        true,
+                        "Checking links of EMLSR client " + std::to_string(clientId) +
+                            " are all blocked on the AP MLD right after the end of CF-End");
+                }
+            });
+        // before the end of the transition delay, all links for the EMLSR client are still
+        // blocked on the AP MLD
+        Simulator::Schedule(
+            txDuration + apPhy->GetSifs() + cfEndTxDuration + m_transitionDelay.at(clientId) -
+                MicroSeconds(1),
+            [=]() {
+                for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
+                {
+                    CheckBlockedLink(
+                        m_apMac,
+                        *addr,
+                        id,
+                        WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY,
+                        true,
+                        "Checking links of EMLSR client " + std::to_string(clientId) +
+                            " are all blocked on the AP MLD before the end of transition delay");
+                }
+            });
+        // immediately after the transition delay, all links for the EMLSR client are unblocked
+        Simulator::Schedule(
+            txDuration + apPhy->GetSifs() + cfEndTxDuration + m_transitionDelay.at(clientId) +
+                MicroSeconds(1),
+            [=]() {
+                for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
+                {
+                    CheckBlockedLink(
+                        m_apMac,
+                        *addr,
+                        id,
+                        WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY,
+                        false,
+                        "Checking links of EMLSR client " + std::to_string(clientId) +
+                            " are all unblocked on the AP MLD after the transition delay");
                 }
             });
-
-        // corrupt this BlockAck so that the AP MLD sends a BlockAckReq later on
-        auto uid = psduMap.cbegin()->second->GetPacket()->GetUid();
-        m_errorModel->SetList({uid});
         break;
     }
 }
